import{s as it,f as et,n as st,o as ot}from"../chunks/scheduler.37c15a92.js";import{S as lt,i as at,g as s,s as o,r as rt,A as ut,h as l,f as n,c as a,j as nt,u as gt,x as r,k as L,y as mt,a as i,v as ct,d as pt,t as ht,w as ft}from"../chunks/index.7cb9c9b8.js";import{H as dt}from"../chunks/Heading.d3928e2a.js";function vt(R){let u,H,M,U,g,C,m,O,P,c,B=`One of the challenges in Reinforcement Learning is <strong>creating environments</strong>. Fortunately for us, we can use game engines to do so.
These engines, such as <a href="https://unity.com/" rel="nofollow">Unity</a>, <a href="https://godotengine.org/" rel="nofollow">Godot</a> or <a href="https://www.unrealengine.com/" rel="nofollow">Unreal Engine</a>, are programs made to create video games. They are perfectly suited
for creating environments: they provide physics systems, 2D/3D rendering, and more.`,A,p,J='One of them, <a href="https://unity.com/" rel="nofollow">Unity</a>, created the <a href="https://github.com/Unity-Technologies/ml-agents" rel="nofollow">Unity ML-Agents Toolkit</a>, a plugin based on the game engine Unity that allows us <strong>to use the Unity Game Engine as an environment builder to train agents</strong>. In the first bonus unit, this is what we used to train Huggy to catch a stick!',k,h,K='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/example-envs.png" alt="MLAgents environments"/> <figcaption>Source: <a href="https://github.com/Unity-Technologies/ml-agents">ML-Agents documentation</a></figcaption>',E,f,N="Unity ML-Agents Toolkit provides many exceptional pre-made environments, from playing football (soccer), learning to walk, and jumping over big walls.",$,d,Q="In this Unit, we’ll learn to use ML-Agents, but <strong>don’t worry if you don’t know how to use the Unity Game Engine</strong>: you don’t need to use it to train your agents.",I,v,V="So, today, we’re going to train two agents:",G,y,W="<li>The first one will learn to <strong>shoot snowballs onto a spawning target</strong>.</li> <li>The second needs to <strong>press a button to spawn a pyramid, then navigate to the pyramid, knock it over, and move to the gold brick at the top</strong>. To do that, it will need to explore its environment, which will be done using a technique called curiosity.</li>",S,w,X,z,_,Y="Then, after training, <strong>you’ll push the trained agents to the Hugging Face Hub</strong>, and you’ll be able to <strong>visualize them playing directly on your browser without having to use the Unity Editor</strong>.",j,x,Z="Doing this Unit will <strong>prepare you for the next challenge: AI vs. AI where you will train agents in multi-agents environments and compete against your classmates’ agents</strong>.",q,T,tt="Sound exciting? Let’s get started!",D,b,F;return g=new dt({props:{title:"An Introduction to Unity ML-Agents",local:"introduction-to-ml-agents",headingTag:"h1"}}),{c(){u=s("meta"),H=o(),M=s("p"),U=o(),rt(g.$$.fragment),C=o(),m=s("img"),P=o(),c=s("p"),c.innerHTML=B,A=o(),p=s("p"),p.innerHTML=J,k=o(),h=s("figure"),h.innerHTML=K,E=o(),f=s("p"),f.textContent=N,$=o(),d=s("p"),d.innerHTML=Q,I=o(),v=s("p"),v.textContent=V,G=o(),y=s("ul"),y.innerHTML=W,S=o(),w=s("img"),z=o(),_=s("p"),_.innerHTML=Y,j=o(),x=s("p"),x.innerHTML=Z,q=o(),T=s("p"),T.textContent=tt,D=o(),b=s("p"),this.h()},l(t){const e=ut("svelte-u9bgzb",document.head);u=l(e,"META",{name:!0,content:!0}),e.forEach(n),H=a(t),M=l(t,"P",{}),nt(M).forEach(n),U=a(t),gt(g.$$.fragment,t),C=a(t),m=l(t,"IMG",{src:!0,alt:!0}),P=a(t),c=l(t,"P",{"data-svelte-h":!0}),r(c)!=="svelte-1vcgfrn"&&(c.innerHTML=B),A=a(t),p=l(t,"P",{"data-svelte-h":!0}),r(p)!=="svelte-eyae6a"&&(p.innerHTML=J),k=a(t),h=l(t,"FIGURE",{"data-svelte-h":!0}),r(h)!=="svelte-14xtn5a"&&(h.innerHTML=K),E=a(t),f=l(t,"P",{"data-svelte-h":!0}),r(f)!=="svelte-1d33h02"&&(f.textContent=N),$=a(t),d=l(t,"P",{"data-svelte-h":!0}),r(d)!=="svelte-w4zwn2"&&(d.innerHTML=Q),I=a(t),v=l(t,"P",{"data-svelte-h":!0}),r(v)!=="svelte-2xi7mi"&&(v.textContent=V),G=a(t),y=l(t,"UL",{"data-svelte-h":!0}),r(y)!=="svelte-15sbbs0"&&(y.innerHTML=W),S=a(t),w=l(t,"IMG",{src:!0,alt:!0}),z=a(t),_=l(t,"P",{"data-svelte-h":!0}),r(_)!=="svelte-14hc6j"&&(_.innerHTML=Y),j=a(t),x=l(t,"P",{"data-svelte-h":!0}),r(x)!=="svelte-11di5c1"&&(x.innerHTML=Z),q=a(t),T=l(t,"P",{"data-svelte-h":!0}),r(T)!=="svelte-1lrk2z4"&&(T.textContent=tt),D=a(t),b=l(t,"P",{}),nt(b).forEach(n),this.h()},h(){L(u,"name","hf:doc:metadata"),L(u,"content",yt),et(m.src,O="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/thumbnail.png")||L(m,"src",O),L(m,"alt","thumbnail"),et(w.src,X="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/envs.png")||L(w,"src",X),L(w,"alt","Environments")},m(t,e){mt(document.head,u),i(t,H,e),i(t,M,e),i(t,U,e),ct(g,t,e),i(t,C,e),i(t,m,e),i(t,P,e),i(t,c,e),i(t,A,e),i(t,p,e),i(t,k,e),i(t,h,e),i(t,E,e),i(t,f,e),i(t,$,e),i(t,d,e),i(t,I,e),i(t,v,e),i(t,G,e),i(t,y,e),i(t,S,e),i(t,w,e),i(t,z,e),i(t,_,e),i(t,j,e),i(t,x,e),i(t,q,e),i(t,T,e),i(t,D,e),i(t,b,e),F=!0},p:st,i(t){F||(pt(g.$$.fragment,t),F=!0)},o(t){ht(g.$$.fragment,t),F=!1},d(t){t&&(n(H),n(M),n(U),n(C),n(m),n(P),n(c),n(A),n(p),n(k),n(h),n(E),n(f),n($),n(d),n(I),n(v),n(G),n(y),n(S),n(w),n(z),n(_),n(j),n(x),n(q),n(T),n(D),n(b)),n(u),ft(g,t)}}}const yt='{"title":"An Introduction to Unity ML-Agents","local":"introduction-to-ml-agents","sections":[],"depth":1}';function wt(R){return ot(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Lt extends lt{constructor(u){super(),at(this,u,wt,vt,it,{})}}export{Lt as component};
