import{s as Ce,n as be,o as Me}from"../chunks/scheduler.37c15a92.js";import{S as xe,i as ye,g as r,s as a,r as A,A as He,h as s,f as i,c as l,j as Te,u as P,x as o,k as _e,y as Re,a as n,v as q,d as D,t as E,w as I}from"../chunks/index.7cb9c9b8.js";import{H as z}from"../chunks/Heading.d3928e2a.js";function ke(re){let u,F,R,U,f,j,m,se="While most of the RL methods seen in this course work well in practice, there are some cases where using them alone fails. This can happen, for instance, when:",O,p,oe="<li>the task to learn is hard and requires an <strong>incremental acquisition of skills</strong> (for instance when one wants to make a bipedal agent learn to go through hard obstacles, it must first learn to stand, then walk, then maybe jump…)</li> <li>there are variations in the environment (that affect the difficulty) and one wants its agent to be <strong>robust</strong> to them</li>",S,c,ue='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/bipedal.gif" alt="Bipedal"/> <img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/movable_creepers.gif" alt="Movable creepers"/> <figcaption><a href="https://developmentalsystems.org/TeachMyAgent/">TeachMyAgent</a></figcaption>',B,h,fe="In such cases, it seems needed to propose different tasks to our RL agent and organize them such that the agent progressively acquires skills. This approach is called <strong>Curriculum Learning</strong> and usually implies a hand-designed curriculum (or set of tasks organized in a specific order). In practice, one can, for instance, control the generation of the environment, the initial states, or use Self-Play and control the level of opponents proposed to the RL agent.",G,g,me="As designing such a curriculum is not always trivial, the field of <strong>Automatic Curriculum Learning (ACL) proposes to design approaches that learn to create such an organization of tasks in order to maximize the RL agent’s performances</strong>. Portelas et al. proposed to define ACL as:",K,d,pe="<p>… a family of mechanisms that automatically adapt the distribution of training data by learning to adjust the selection of learning situations to the capabilities of RL agents.</p>",Q,v,ce="As an example, OpenAI used <strong>Domain Randomization</strong> (they applied random variations on the environment) to make a robot hand solve Rubik’s Cubes.",W,L,he='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/dr.jpg" alt="Dr"/> <figcaption><a href="https://openai.com/blog/solving-rubiks-cube/">OpenAI - Solving Rubik’s Cube with a Robot Hand</a></figcaption>',J,w,ge='Finally, you can play with the robustness of agents trained in the <a href="https://huggingface.co/spaces/flowers-team/Interactive_DeepRL_Demo">TeachMyAgent</a> benchmark by controlling environment variations or even drawing the terrain 👇',N,$,de='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/demo.png" alt="Demo"/> <figcaption><a href="https://huggingface.co/spaces/flowers-team/Interactive_DeepRL_Demo">https://huggingface.co/spaces/flowers-team/Interactive_DeepRL_Demo</a></figcaption>',V,T,X,_,ve="For more information, we recommend that you check out the following resources:",Y,C,Z,b,Le='<li><a href="https://arxiv.org/pdf/2003.04664.pdf" rel="nofollow">Automatic Curriculum Learning For Deep RL: A Short Survey</a></li> <li><a href="https://lilianweng.github.io/posts/2020-01-29-curriculum-rl/" rel="nofollow">Curriculum for Reinforcement Learning</a></li>',ee,M,te,x,we='<li><a href="https://arxiv.org/abs/2203.01302" rel="nofollow">Evolving Curricula with Regret-Based Environment Design</a></li> <li><a href="https://proceedings.mlr.press/v162/klink22a.html" rel="nofollow">Curriculum Reinforcement Learning via Constrained Optimal Transport</a></li> <li><a href="https://arxiv.org/abs/2010.03934" rel="nofollow">Prioritized Level Replay</a></li>',ie,y,ne,H,$e='This section was written by <a href="https://twitter.com/ClementRomac">Clément Romac</a>',ae,k,le;return f=new z({props:{title:"(Automatic) Curriculum Learning for RL",local:"automatic-curriculum-learning-for-rl",headingTag:"h1"}}),T=new z({props:{title:"Further reading",local:"further-reading",headingTag:"h2"}}),C=new z({props:{title:"Overview of the field",local:"overview-of-the-field",headingTag:"h3"}}),M=new z({props:{title:"Recent methods",local:"recent-methods",headingTag:"h3"}}),y=new z({props:{title:"Author",local:"author",headingTag:"h2"}}),{c(){u=r("meta"),F=a(),R=r("p"),U=a(),A(f.$$.fragment),j=a(),m=r("p"),m.textContent=se,O=a(),p=r("ul"),p.innerHTML=oe,S=a(),c=r("figure"),c.innerHTML=ue,B=a(),h=r("p"),h.innerHTML=fe,G=a(),g=r("p"),g.innerHTML=me,K=a(),d=r("blockquote"),d.innerHTML=pe,Q=a(),v=r("p"),v.innerHTML=ce,W=a(),L=r("figure"),L.innerHTML=he,J=a(),w=r("p"),w.innerHTML=ge,N=a(),$=r("figure"),$.innerHTML=de,V=a(),A(T.$$.fragment),X=a(),_=r("p"),_.textContent=ve,Y=a(),A(C.$$.fragment),Z=a(),b=r("ul"),b.innerHTML=Le,ee=a(),A(M.$$.fragment),te=a(),x=r("ul"),x.innerHTML=we,ie=a(),A(y.$$.fragment),ne=a(),H=r("p"),H.innerHTML=$e,ae=a(),k=r("p"),this.h()},l(e){const t=He("svelte-u9bgzb",document.head);u=s(t,"META",{name:!0,content:!0}),t.forEach(i),F=l(e),R=s(e,"P",{}),Te(R).forEach(i),U=l(e),P(f.$$.fragment,e),j=l(e),m=s(e,"P",{"data-svelte-h":!0}),o(m)!=="svelte-divgy0"&&(m.textContent=se),O=l(e),p=s(e,"UL",{"data-svelte-h":!0}),o(p)!=="svelte-1fijmic"&&(p.innerHTML=oe),S=l(e),c=s(e,"FIGURE",{"data-svelte-h":!0}),o(c)!=="svelte-259cr2"&&(c.innerHTML=ue),B=l(e),h=s(e,"P",{"data-svelte-h":!0}),o(h)!=="svelte-16unqvo"&&(h.innerHTML=fe),G=l(e),g=s(e,"P",{"data-svelte-h":!0}),o(g)!=="svelte-t9kiqj"&&(g.innerHTML=me),K=l(e),d=s(e,"BLOCKQUOTE",{"data-svelte-h":!0}),o(d)!=="svelte-1i9zwqs"&&(d.innerHTML=pe),Q=l(e),v=s(e,"P",{"data-svelte-h":!0}),o(v)!=="svelte-q06j09"&&(v.innerHTML=ce),W=l(e),L=s(e,"FIGURE",{"data-svelte-h":!0}),o(L)!=="svelte-habslb"&&(L.innerHTML=he),J=l(e),w=s(e,"P",{"data-svelte-h":!0}),o(w)!=="svelte-4l6fnl"&&(w.innerHTML=ge),N=l(e),$=s(e,"FIGURE",{"data-svelte-h":!0}),o($)!=="svelte-15rau72"&&($.innerHTML=de),V=l(e),P(T.$$.fragment,e),X=l(e),_=s(e,"P",{"data-svelte-h":!0}),o(_)!=="svelte-144wssd"&&(_.textContent=ve),Y=l(e),P(C.$$.fragment,e),Z=l(e),b=s(e,"UL",{"data-svelte-h":!0}),o(b)!=="svelte-19o2s58"&&(b.innerHTML=Le),ee=l(e),P(M.$$.fragment,e),te=l(e),x=s(e,"UL",{"data-svelte-h":!0}),o(x)!=="svelte-1cnmd2q"&&(x.innerHTML=we),ie=l(e),P(y.$$.fragment,e),ne=l(e),H=s(e,"P",{"data-svelte-h":!0}),o(H)!=="svelte-a8x2u9"&&(H.innerHTML=$e),ae=l(e),k=s(e,"P",{}),Te(k).forEach(i),this.h()},h(){_e(u,"name","hf:doc:metadata"),_e(u,"content",Ae)},m(e,t){Re(document.head,u),n(e,F,t),n(e,R,t),n(e,U,t),q(f,e,t),n(e,j,t),n(e,m,t),n(e,O,t),n(e,p,t),n(e,S,t),n(e,c,t),n(e,B,t),n(e,h,t),n(e,G,t),n(e,g,t),n(e,K,t),n(e,d,t),n(e,Q,t),n(e,v,t),n(e,W,t),n(e,L,t),n(e,J,t),n(e,w,t),n(e,N,t),n(e,$,t),n(e,V,t),q(T,e,t),n(e,X,t),n(e,_,t),n(e,Y,t),q(C,e,t),n(e,Z,t),n(e,b,t),n(e,ee,t),q(M,e,t),n(e,te,t),n(e,x,t),n(e,ie,t),q(y,e,t),n(e,ne,t),n(e,H,t),n(e,ae,t),n(e,k,t),le=!0},p:be,i(e){le||(D(f.$$.fragment,e),D(T.$$.fragment,e),D(C.$$.fragment,e),D(M.$$.fragment,e),D(y.$$.fragment,e),le=!0)},o(e){E(f.$$.fragment,e),E(T.$$.fragment,e),E(C.$$.fragment,e),E(M.$$.fragment,e),E(y.$$.fragment,e),le=!1},d(e){e&&(i(F),i(R),i(U),i(j),i(m),i(O),i(p),i(S),i(c),i(B),i(h),i(G),i(g),i(K),i(d),i(Q),i(v),i(W),i(L),i(J),i(w),i(N),i($),i(V),i(X),i(_),i(Y),i(Z),i(b),i(ee),i(te),i(x),i(ie),i(ne),i(H),i(ae),i(k)),i(u),I(f,e),I(T,e),I(C,e),I(M,e),I(y,e)}}}const Ae='{"title":"(Automatic) Curriculum Learning for RL","local":"automatic-curriculum-learning-for-rl","sections":[{"title":"Further reading","local":"further-reading","sections":[{"title":"Overview of the field","local":"overview-of-the-field","sections":[],"depth":3},{"title":"Recent methods","local":"recent-methods","sections":[],"depth":3}],"depth":2},{"title":"Author","local":"author","sections":[],"depth":2}],"depth":1}';function Pe(re){return Me(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ie extends xe{constructor(u){super(),ye(this,u,Pe,ke,Ce,{})}}export{Ie as component};
